# Running a QuickPeep Seed Collection Service

The QuickPeep web interface has a built-in seed collection page at `/seeds`.
This is a simple form where anyone can submit a URL and tag it with appropriate tags.

The list of tags can be changed in `quickpeep.ron` (`web` → `seed_collection` → ...).


## Retrieving seeds from the Seed Collection Service

First use the `qp-seedcoll-sort` utility included with QuickPeep to sort through the seeds that you have received.
For each seed that has been received on the web interface, but not yet sorted, you will be given the option to:

- accept (`y`)
- reject
    - generic reason (`n`)
    - because it duplicates an existing entry (`dupe`)
    - because it's spam (`spam`)
    - because it's invalid for some reason; e.g. the URL isn't valid (`inv`)

This just marks the seeds in the database but doesn't yet emit them in a format usable by the QuickPeep raker.
To export the seeds, use `qp-seedcoll-dump path/to/new/file.seed`.
This command writes a seed file (usable by the Raker) for all the seeds that haven't yet been dumped.

Getting the seeds from your web UI to the Raker is an exercise left for the reader, but I will note that I do this by committing them into a Git repository, with each seed file being dated.
This also has the benefit of being able to easily publish them for others to use; my seeds are available at https://git.emunest.net/reivilibre/quickpeep_seeds.
