use fancy_mdbx::database::RawTable;
use fancy_mdbx::environment::Env;
use std::path::Path;

pub struct IconStore {
    pub env: Env,

    /// Icons table
    /// u64 hashes (little endian) to WebP contents
    pub icons: RawTable<[u8], [u8]>,
}

impl IconStore {
    pub fn open(path: &Path) -> anyhow::Result<IconStore> {
        let env = Env::open(path)?;
        let icons = env.open_raw_table(Some("icons"), ())?;

        Ok(IconStore { env, icons })
    }
}
