use serde::{Deserialize, Serialize};
use std::path::PathBuf;

#[derive(Serialize, Deserialize, Debug, Clone)]
#[serde(tag = "type")]
pub enum BackendConfig {
    #[serde(rename = "tantivy")]
    Tantivy(TantivyBackendConfig),
    #[serde(rename = "meili")]
    Meili(MeiliBackendConfig),
}

#[derive(Serialize, Deserialize, Debug, Clone)]
pub struct TantivyBackendConfig {
    pub index_dir: PathBuf,
}

#[derive(Serialize, Deserialize, Debug, Clone)]
pub struct MeiliBackendConfig {
    pub url: String,
    pub token: String,
}
