use std::borrow::Cow;
use url::Url;

pub fn get_reduced_domain(url: &Url) -> Option<Cow<'_, str>> {
    // If the URL does not have a host or not a domain (e.g. IP address) then exits with None here.
    let domain = url.domain()?;

    Some(Cow::Borrowed(match domain.strip_prefix("www.") {
        Some(stripped) => stripped,
        None => domain,
    }))
}
